    001/* ========================================================================
    002 * JCommon : a free general purpose class library for the Java(tm) platform
    003 * ========================================================================
    004 *
    005 * (C) Copyright 2000-2005, by Object Refinery Limited and Contributors.
    006 *
    007 * Project Info:  http://www.jfree.org/jcommon/index.html
    008 *
    009 * This library is free software; you can redistribute it and/or modify it
    010 * under the terms of the GNU Lesser General Public License as published by
    011 * the Free Software Foundation; either version 2.1 of the License, or
    012 * (at your option) any later version.
    013 *
    014 * This library is distributed in the hope that it will be useful, but
    015 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017 * License for more details.
    018 *
    019 * You should have received a copy of the GNU Lesser General Public
    020 * License along with this library; if not, write to the Free Software
    021 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022 * USA.
    023 *
    024 * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025 * in the United States and other countries.]
    026 *
    027 * -----------------------------
    028 * Point2DObjectDescription.java
    029 * -----------------------------
    030 * (C)opyright 2003, 2004, by Thomas Morgner and Contributors.
    031 *
    032 * Original Author:  Thomas Morgner;
    033 * Contributor(s):   David Gilbert (for Object Refinery Limited);
    034 *
    035 * $Id: Point2DObjectDescription.java,v 1.3 2005/11/14 11:03:35 mungady Exp $
    036 *
    037 * Changes (from 19-Feb-2003)
    038 * -------------------------
    039 * 19-Feb-2003 : Added standard header and Javadocs (DG);
    040 * 29-Apr-2003 : Distilled from the JFreeReport project and moved into JCommon
    041 *
    042 */
    043
    044package org.jfree.xml.factory.objects;
    045
    046import java.awt.geom.Point2D;
    047
    048/**
    049 * An object-description for a <code>Point2D</code> object.
    050 *
    051 * @author Thomas Morgner
    052 */
    053public class Point2DObjectDescription extends AbstractObjectDescription {
    054
    055    /**
    056     * Creates a new object description.
    057     */
    058    public Point2DObjectDescription() {
    059        super(Point2D.class);
    060        setParameterDefinition("x", Float.class);
    061        setParameterDefinition("y", Float.class);
    062    }
    063
    064    /**
    065     * Creates an object based on this description.
    066     *
    067     * @return The object.
    068     */
    069    public Object createObject() {
    070        final Point2D point = new Point2D.Float();
    071
    072        final float x = getFloatParameter("x");
    073        final float y = getFloatParameter("y");
    074        point.setLocation(x, y);
    075        return point;
    076    }
    077
    078    /**
    079     * Returns a parameter value as a float.
    080     *
    081     * @param param  the parameter name.
    082     *
    083     * @return The float value.
    084     */
    085    private float getFloatParameter(final String param) {
    086        final Float p = (Float) getParameter(param);
    087        if (p == null) {
    088            return 0;
    089        }
    090        return p.floatValue();
    091    }
    092
    093    /**
    094     * Sets the parameters of this description object to match the supplied object.
    095     *
    096     * @param o  the object (should be an instance of <code>Point2D</code>).
    097     *
    098     * @throws ObjectFactoryException if the object is not an instance of <code>Point2D</code>.
    099     */
    100    public void setParameterFromObject(final Object o) throws ObjectFactoryException {
    101        if (!(o instanceof Point2D)) {
    102            throw new ObjectFactoryException("The given object is no java.awt.geom.Point2D.");
    103        }
    104
    105        final Point2D point = (Point2D) o;
    106        final float x = (float) point.getX();
    107        final float y = (float) point.getY();
    108
    109        setParameter("x", new Float(x));
    110        setParameter("y", new Float(y));
    111    }
    112}